Subject: RE: Newbie ssh question
From: "James Hall" <[email-masked]>
To: "Jeff Mincy" <[email-masked]>, "Adrian Phillips" <[email-masked]>
Cc: <[email-masked]>
Date: Mon, 7 Jan 2002 16:26:09 -0000

Thanks for responding to my original question.

Although not strictly correct you pointed me in the right direction. For any
one else with this problem:

In order to use TCP keep alive on W2K the appropriate registry entries are:-

Key; HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters
Values: KeepAliveTime and KeepAliveInterval

The M$ documentation on these is both somewhat vague and misleading. The
second value is the interval between keep-alive packets to be sent when no
reply has been received from the remote host (the number sent before giving
up being determined by the MaxDataRetries value) - the suggested value of
1000 (1000ms = 1s) is sensible. The first value is the time to wait before
sending a keep-alive message - the suggested value of 7200000 (=2hrs) is
nonsensical if intervening firewalls are detecting and blocking quiescent
connections. A value of 1s is more appropriate and is well on the safe side.

By default neither of these values is included in the registry. I have added
them, observed using TCPdump that they now cause keep-alives to be sent, and
all is now well.

Incidentally, the W98 etc registry key
HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\VxD\MSTCP is also
present in the W2K registry - I have also added the above values to this
key, with no ill effects.

I find prodding around in the registry slightly less scary than tweaking
unix/linux config files, though the required reboots thereafter are a pain
in the ar**.

Thanks again - and to all the Cygwin/XFree86 developers for an excellent
product.

James

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On Behalf
> Of Jeff Mincy
> Sent: 06 January 2002 20:55
> To: Adrian Phillips
> Cc: James Hall; [email-masked]
> Subject: Re: Newbie ssh question
>
>
>    From: Adrian Phillips <[email-masked]>
>    Date: 06 Jan 2002 11:15:46 +0100
>
>    >>>>> "James" == James Hall <[email-masked]> writes:
>
>        James> I've recently installed Cygwin and XFree86 on my W2K
>        James> machine, and am highly pleased with it.
>
>        James> Main use is to run stuff on my machine at work, and saves
>        James> constantly re-booting between Windows and Linux on my home
>        James> machine.
>
>        James> I consequently make much use of ssh and X forwarding. All
>        James> works excellently, but for one problem. Any remote Xterm,
>        James> unless used pretty constantly, falls over with the message
>
>        James> 	"Read from remote host x.x.x.x: Connection
> reset by peer
>        James> Connection to x.x.x.x closed."
>
>    Do you have a firewall in between. Firewalls throw away connections
>    when there unused for a while,
>
> For example, Sonicwalls have Network Connection Inactivity Timeout
>
>    Try turning on KeepALive (or whatever the option is called now),
>
> Also, there is how hard windows tries to keep connections alive.
>
> This is in the PuttyFAQ
>
>  The timeout value can't be set on per application or per session
>  basis. To increase the TCP timeout globally, you need to add the
>  following key to the registry
>
> HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\VxD\MSTCP\Max
> DataRetries
>  in Win95/98/ME (it must be DWORD in Win95, or String in Win98/ME),
>
>  Then set the key's value to something like 10. This will cause
>  Windows to try harder to keep connections alive instead of
>  abandoning them.
>
> P.S. Have fun doing regedit.
> P.P.S, do be careful.  This would be a good time to backup your machine.
>
>    Your mouse has moved.
>    Windows NT must be restarted for the change to take effect.
>    Reboot now?  [OK]
>
> Snirk.
>
> -jeff
>
>
> --
> Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
> Bug reporting:         http://cygwin.com/bugs.html
> Documentation:         http://cygwin.com/docs.html
> FAQ:                   http://cygwin.com/faq/
>
>

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/